# Memsource Developer Assignment

## Project structure

Project is divided into 2 modules - backend and frontend. Backend uses **SpringBoot**, frontend is written in **react.js**

## How to start the solution
### Prerequisities
- JDK 1.8
- maven 3.3+
- node.js 10+
- yarn 1.17+

### Backend
Assuming you have java and maven properly installed and configured, the backend can be started by running **mvn spring-boot:run** inside backend folder. This would start backend services listening at port 8080. There is also swagger bundled within the solution. You can check whether backend is up and running by visiting **http://localhost:8080/api/swagger-ui.html**

### Frontend
Nodejs dependencies must be installed first by running **yarn install** inside frontend folder. Once are the dependecies installed, type **yarn start**. Frontend would be available at **http://localhost:3000**

## TODOs

There are several things that were not possible to deliver within required 4-5 hours. 

- configuration validation would be good on backend
- there should be more comments in the code
- paging is not implemented on frontend
- UX was taken from material-ui project, however some styling should be better
- there should be some value-translations on frontend (status, language tags, etc.) instead of displaying raw values
- error handling and reporting could have been better
- initially, there were plans to create docker image containing the whole solution :-)